using System;
using System.Reflection;
using System.Collections;
using System.Runtime.CompilerServices;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Mod
{
    public class undeath : MonoBehaviour
    {
        private LimbBehaviour limb;
		//public const bool untrue = false;
		private float oStrength;
		private float oMass;
		private Vector3 oScale;
		private Vector3 oLScale;
		private FieldInfo _field;


	private void Awake()
	{
		foreach (var Intercept in gameObject.GetComponents<ConnectedNodeBehaviour>())
		{
			DestroyImmediate(Intercept);
		}
	}

    private void Start()
        {
            limb = GetComponent<LimbBehaviour>();
			limb.enabled = true;
			oScale = limb.gameObject.transform.parent.localScale;
			oLScale = limb.gameObject.transform.localScale;
			limb.PhysicalBehaviour.RecalculateMassBasedOnSize();
			oMass = limb.PhysicalBehaviour.InitialMass*5;
			limb.PhysicalBehaviour.rigidbody.mass = oMass;
			//oStrength = 12.5f*(limb.PhysicalBehaviour.rigidbody.mass/limb.PhysicalBehaviour.TrueInitialMass);
			oStrength = limb.BaseStrength;
			_field = limb.NodeBehaviour.GetType().GetFields(BindingFlags.Instance | BindingFlags.Static | BindingFlags.Public | BindingFlags.NonPublic).FirstOrDefault(f => f.Name == "<IsConnectedToRoot>k__BackingField");
			CreateContextMenuOptions();
			StartCoroutine(lechenie(limb));
			StartCoroutine(laggystuff(limb));
        }
		
private IEnumerator lechenie(LimbBehaviour limb)
{
	while(true)
	{
		if (!limb.IsConsideredAlive)
		{
			Destroy(this);
		}
		if(!limb.IsCapable)
		{
			Destroy(this);
		}
		limb.HealBone();//ඞ
			limb.GetComponent<CirculationBehaviour>().HealBleeding();
			limb.PhysicalBehaviour.BurnProgress = 0f;
			limb.SkinMaterialHandler.ClearAllDamage();
			limb.InitialHealth = float.MaxValue;
			limb.Health = float.PositiveInfinity;
			limb.RegenerationSpeed = float.PositiveInfinity;
			limb.IsLethalToBreak = false;
			/*limb.NodeBehaviour.IsRoot = true;
			limb.NodeBehaviour.RootPropagation();*/
			_field.SetValue(limb.NodeBehaviour, true);
			limb.Numbness = float.NegativeInfinity;
			limb.GetComponent<CirculationBehaviour>().AddLiquid(limb.GetOriginalBloodType(), float.PositiveInfinity);
			limb.GetComponent<CirculationBehaviour>().ForceSetAllLiquid(float.PositiveInfinity);
			limb.ExplodeLiquidAmount = float.PositiveInfinity;
			limb.Person.ShockLevel = 0f;
			limb.Person.PainLevel = 0f;
			limb.GetComponent<LimbBehaviour>().Frozen = false;
			limb.PhysicalBehaviour.Properties.Softness = 0f;
			limb.BreakingThreshold = float.PositiveInfinity;
			if (limb.TryGetComponent(out HingeJoint2D Joint))
			{
				Joint.breakForce = float.PositiveInfinity;
				Joint.breakTorque = float.PositiveInfinity;
			} //ඞ
			limb.ImmuneToDamage = true;
			limb.GetComponent<CirculationBehaviour>().ImmuneToDamage = true;
			limb.IsDismembered = false;
			limb.GetComponent<CirculationBehaviour>().IsDisconnected = false;
			limb.PhysicalBehaviour.Charge = 0f;
			limb.Person.AdrenalineLevel = float.PositiveInfinity;
			limb.BruiseCount = (ushort)0;
			limb.GetComponent<CirculationBehaviour>().GunshotWoundCount = (ushort)0;
			limb.GetComponent<CirculationBehaviour>().StabWoundCount = (ushort)0;
			limb.PhysicalBehaviour.Disintegratable = false;
			limb.PhysicalBehaviour.Deletable = false;
			limb.PhysicalBehaviour.Resizable = false;
			limb.PhysicalBehaviour.ChargeBurns = false;
			limb.PhysicalBehaviour.ForceNoCharge = false;
			limb.PhysicalBehaviour.ForceNoChargeParticles = true;
			limb.Person.Consciousness = float.PositiveInfinity;
			limb.Person.OxygenLevel = float.PositiveInfinity;
			limb.PhysicalBehaviour.SimulateTemperature = false;
			//limb.Wince(0f); //🗿ඞ
			limb.Vitality = 0f;
			limb.GetComponent<CirculationBehaviour>().IsPump = limb.GetComponent<CirculationBehaviour>().WasInitiallyPumping;
			limb.GetComponent<CirculationBehaviour>().BloodFlow = 100f;
			//oStrength = 12.5f*(limb.PhysicalBehaviour.rigidbody.mass/limb.PhysicalBehaviour.TrueInitialMass); //ඞ
			limb.BaseStrength = oStrength;
			limb.BodyTemperature = 37f;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 37f;
			/*Component[] components = limb.gameObject.GetComponents(typeof(Component));
			foreach(Component component in components) 
			{
				if(component != GetComponent<undeath>() & component != GetComponent<Transform>() & component != GetComponent<SpriteRenderer>() & component != GetComponent<BoxCollider2D>() & component != GetComponent<Rigidbody2D>() & component != GetComponent<PhysicalBehaviour>() & component != GetComponent<LimbBehaviour>() & component != GetComponent<HingeJoint2D>() & component != GetComponent<SkinMaterialHandler>() & component != GetComponent<CirculationBehaviour>() & component != GetComponent<ShotMessagePropagator>() & component != GetComponent<ContextMenuOptionComponent>() & component != GetComponent<AudioSource>() & component != GetComponent<SerialisableIdentity>() & component != GetComponent<GripBehaviour>() & component != GetComponent<FixedJoint2D>() & component != GetComponent<SpringJoint2D>() & component != GetComponent<SliderJoint2D>() & component != GetComponent<Hover>() & component != GetComponent<FreezeBehaviour>())
				{
					DestroyImmediate(component);
				}
			}*/

			yield return new WaitForEndOfFrame();
	}
}

private void CreateContextMenuOptions()
{
	this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("DeleteUnliving", "Delete Unliving Object", "Delete Unlivivng Object", () =>
	{
		Destroy(limb.gameObject.transform.root.gameObject);
	}));
}
		
private IEnumerator laggystuff(LimbBehaviour limb)
{
	while(true)
	{
		limb.gameObject.GetComponent<Rigidbody2D>().drag = 0.05f;
		limb.gameObject.GetComponent<Rigidbody2D>().angularDrag = 0.05f;
		limb.PhysicalBehaviour.rigidbody.mass = oMass;
		limb.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
		limb.IsAndroid = false;
		limb.IsZombie = false;
		limb.gameObject.transform.parent.localScale = oScale;
		limb.gameObject.transform.localScale = oLScale;
		limb.ImpactPainMultiplier = 0f;
		limb.ShotDamageMultiplier = 0f;
		limb.PhysicalBehaviour.Properties.Flammability = 0f;
		limb.DoStumble = false;
		limb.DoBalanceJerk = false;
		limb.BloodDecal = null;
		
		yield return new WaitForSeconds(1f);
	}
}

 private void FixedUpdate()
	{
		limb.PhysicalBehaviour.Wetness = Mathf.Clamp(limb.PhysicalBehaviour.Wetness,0f,0.2f);
	}
private void OnDestroy()
	{
		StopAllCoroutines();
		limb.gameObject.AddComponent<undeath>();
	}
private void OnDisable()
	{
		this.gameObject.SetActive(true);
		GetComponent<undeath>().enabled = true;
	}
    }
}
// Originally uploaded by '󠀦󠀦hunter'. Do not reupload without their explicit permission.
